Graphics 800,100,16,2
ClsColor 255,0,255
Cls

AppTitle "Stranded II Textgen V 1.0, 04.01.2008"

SetFont LoadFont("Arial",20,1)
Color 0,0,0

Const bmpf_count=6
Dim bmpf_image(bmpf_count)
Dim bmpf_frames(bmpf_count)
Dim bmpf_framesx(bmpf_count)
Dim bmpf_framesy(bmpf_count)
Dim bmpf_framesw(255,bmpf_count)
Dim bmpf_framesc(255,bmpf_count)

Function load_image(path$,masked=1)
	Local image=LoadImage(path$)
	If image=0 Then RuntimeError("Unable to load Image "+path$)
	If masked Then MaskImage image,255,0,255
	Return image
End Function

Function con_add(txt$)
End Function

bmpf_load_font("sys\gfx\font_tiny.bmp","sys\gfx\font_tiny.bmpf",5)
bmpf_load_font("sys\gfx\font_norm.bmp","sys\gfx\font_norm.bmpf",0)
bmpf_load_font("sys\gfx\font_norm_over.bmp","sys\gfx\font_norm.bmpf",1)
bmpf_load_font("sys\gfx\font_norm_dark.bmp","sys\gfx\font_norm.bmpf",2)
bmpf_load_font("sys\gfx\font_norm_bad.bmp","sys\gfx\font_norm.bmpf",3)
bmpf_load_font("sys\gfx\font_norm_good.bmp","sys\gfx\font_norm.bmpf",4)
bmpf_load_font("sys\gfx\font_handwriting.bmp","sys\gfx\font_norm.bmpf",6)

Function bmpf_load_font(bmp$,bmpf$,id)
	Local def,i,sign
	If set_debug Then con_add("Loading Font: "+bmp$+" (Inf: "+bmpf+")")
	;Definition laden
	def=ReadFile(bmpf$)
	If Not def Then RuntimeError("Unable to load Bitmapfont "+bmp$)
	ReadLine(def)
	bmpf_frames(id)=ReadShort(def)
	bmpf_framesx(id)=ReadShort(def)
	bmpf_framesy(id)=ReadShort(def)
	For i=1 To bmpf_frames(id)
		sign=ReadByte(def)
		bmpf_framesc(sign,id)=i-1
		bmpf_framesw(sign,id)=ReadShort(def)
	Next
	;Image laden
	bmpf_image(id)=LoadAnimImage(bmp$,bmpf_framesx(id),bmpf_framesy(id),0,bmpf_frames(id))
	MaskImage bmpf_image(id),255,0,255
	;Ok
	Return 1
End Function


Function bmpf_txt(x,y,txt$,id=0)
	Local strlen=Len(txt$)
	Local i,sign
	For i=1 To strlen
		sign=Asc(Mid(txt$,i,1))
		If sign<>32 Then
			DrawImage bmpf_image(id),x,y,bmpf_framesc(sign,id)
			x=x+bmpf_framesw(sign,id)
		Else
			x=x+bmpf_framesx(id)/2
		EndIf
	Next
End Function

Global font
Global txt$


Repeat
	Locate 5,40
	font=Input("Font ID (0-6): ")
	If font<0 Then font=0
	If font>6 Then font=6
	Locate 5,60
	txt$=Input("Text: ")
	Cls
	bmpf_txt(5,5,txt$,font)	
Forever